//
//  DetectionView.m
//  iPhoneCV2
//
//  Created by Pablo Roldán Ruz on 26/10/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "DetectionView.h"

// This class draws a rectangle for each detected face
@implementation DetectionView

@synthesize pathToDraw;
@synthesize frontCamera;


- (void)dealloc {
	if(pathToDraw!=NULL) CGPathRelease(pathToDraw);
    
    [super dealloc];
}

// Initialize the object
- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
        self.frontCamera = YES;
    }
    return self;
}

// Update the path to draw (rectangles)
-(void) setPathToDraw:(CGMutablePathRef) newPath {
	if(pathToDraw!=NULL) 
        CGPathRelease(pathToDraw);
    
	pathToDraw=newPath;
    
	[self setNeedsDisplay];
}


// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
// Draws a rectangle for each face detected
- (void)drawRect:(CGRect)rect
{
    // Drawing code    
    CGContextRef context=UIGraphicsGetCurrentContext();
        
    CGContextSaveGState(context);
    
    if (self.frontCamera) {
        CGContextTranslateCTM(context, self.frame.size.width,0);
        CGContextScaleCTM(context, -1.0, 1.0);
    } else {
        CGContextTranslateCTM(context, 0, 0);
        CGContextScaleCTM(context, 1.0, 1.0);
    }
    
    // do your drawing here
	CGContextSetLineWidth(context, 1);
	CGContextSetStrokeColorWithColor(context, [[UIColor greenColor] CGColor]);
	CGContextAddPath(context, pathToDraw);
    
    CGContextStrokePath(context);
        
    CGContextRestoreGState(context);
}


@end
