//
//  ViewController.h
//  iPhoneCV2
//
//  Created by Pablo Roldán Ruz on 26/10/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>
#import "DetectionView.h"
#import "PhotoConfController.h"


// Main controller.
@interface ViewController : UIViewController<AVCaptureVideoDataOutputSampleBufferDelegate> {
    
    // Capture image from camera
    AVCaptureSession *captureSession;
    AVCaptureDeviceInput *videoInput;
    AVCaptureVideoDataOutput *videoOutput;
    AVCaptureVideoPreviewLayer *previewLayer;    
    dispatch_queue_t cameraQueue;
    UIView *cameraView;
    DetectionView *detectionView;
        
    // Face cascade classifier
    cv::CascadeClassifier faceCascade;
    
    // Frame images
    cv::Mat frameImage;
    cv::Mat grayImage;
    cv::Mat smallImage;
    
    // Scale applied to get the small image
    double scale;    
    
    // Picture taking
    AVCaptureStillImageOutput *stillImageOutput;
    UIView *flashView;
    BOOL pictureTaken;
    
    // Configuration controller
    PhotoConfController *settingsController;
    
    // Number of people in the picture
    UILabel *peopleLabel;
    int numberOfPeopleDetected;
    
    // Take new picture button
    UIBarButtonItem *takeNewPictureButton;
}

@property (nonatomic,retain) IBOutlet UIView *cameraView;
@property (nonatomic,retain) IBOutlet DetectionView *detectionView;
@property (nonatomic,retain) AVCaptureSession *captureSession;
@property (nonatomic,retain) AVCaptureVideoPreviewLayer *previewLayer;
@property (nonatomic,retain) AVCaptureDeviceInput *videoInput;
@property (nonatomic,retain) IBOutlet UILabel *peopleLabel;
@property (nonatomic,retain) IBOutlet PhotoConfController *settingsController;
@property (nonatomic,retain) IBOutlet UIBarButtonItem *takeNewPictureButton;


// Switch between front and back camera
- (IBAction)toggleCamera:(id)sender;

// Take a picture and store it in the album
- (IBAction)takePicture:(id)sender;

// Action for the Settings button
- (IBAction)settings:(id)sender;

// Action for the Take New Picture button
- (IBAction)newPicture:(id)sender;

@end
