//
//  AppDelegate.m
//  Resultados Video
//
//  Created by Pablo Roldán Ruz on 28/11/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"
#import "ResultSet.h"

@interface AppDelegate()
- (void)processFiles;
@end

@implementation AppDelegate

@synthesize window = _window;

@synthesize faceTruePositives;
@synthesize faceFalsePositives;
@synthesize faceFalseNegatives;
@synthesize faceTotalPositives;
@synthesize faceSensitivity;

@synthesize upperBodyTruePositives;
@synthesize upperBodyFalsePositives;
@synthesize upperBodyFalseNegatives;
@synthesize upperBodyTotalPositives;
@synthesize upperBodySensitivity;

@synthesize lowerBodyTruePositives;
@synthesize lowerBodyFalsePositives;
@synthesize lowerBodyFalseNegatives;
@synthesize lowerBodyTotalPositives;
@synthesize lowerBodySensitivity;

@synthesize fullBodyTruePositives;
@synthesize fullBodyFalsePositives;
@synthesize fullBodyFalseNegatives;
@synthesize fullBodyTotalPositives;
@synthesize fullBodySensitivity;


- (void)dealloc
{
    [super dealloc];
}
	
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Load the results and ground truth into the resultsets...
    faceResults = [[ResultSet alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"FaceDetectionResults" ofType:@"txt"]];
                   
    faceGroundTruth = [[ResultSet alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"FaceGroundTruth" ofType:@"txt"]];
    
    upperBodyGroundTruth = [[ResultSet alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"UpperBodyGroundTruth" ofType:@"txt"]];
    upperBodyResults = [[ResultSet alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"UpperBodyDetectionResults" ofType:@"txt"]];
    
    lowerBodyGroundTruth = [[ResultSet alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"LowerBodyGroundTruth" ofType:@"txt"]];
    lowerBodyResults = [[ResultSet alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"LowerBodyDetectionResults" ofType:@"txt"]];
    
    fullBodyGroundTruth = [[ResultSet alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"FullBodyGroundTruth" ofType:@"txt"]];
    fullBodyResults = [[ResultSet alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"FullBodyDetectionResults" ofType:@"txt"]];
    
    
    // Face -- Compare the results to the ground truth
    [faceResults compareTo:faceGroundTruth];
    
    
    int truePositives = [faceResults truePositives];
    int falsePositives = [faceResults falsePositives];
    int falseNegatives = [faceGroundTruth falsePositives];
    int total = [faceGroundTruth numberOfDetections];
    
    self.faceTruePositives.stringValue = [NSString stringWithFormat:@"%d",truePositives];
    self.faceFalsePositives.stringValue = [NSString stringWithFormat:@"%d",falsePositives];
    self.faceFalseNegatives.stringValue = [NSString stringWithFormat:@"%d",falseNegatives];
    self.faceTotalPositives.stringValue = [NSString stringWithFormat:@"%d",total];
    
    float sens = (float)truePositives / (float)(truePositives + falseNegatives);
            
    self.faceSensitivity.stringValue = [NSString stringWithFormat:@"%.5f",sens];
    
    
    // Upper Body -- Compare the results to the ground truth
    [upperBodyResults compareTo:upperBodyGroundTruth];
    
    truePositives = [upperBodyResults truePositives];
    falsePositives = [upperBodyResults falsePositives];
    falseNegatives = [upperBodyGroundTruth falsePositives];
    total = [upperBodyGroundTruth numberOfDetections];
    
    self.upperBodyTruePositives.stringValue = [NSString stringWithFormat:@"%d",truePositives];
    self.upperBodyFalsePositives.stringValue = [NSString stringWithFormat:@"%d",falsePositives];
    self.upperBodyFalseNegatives.stringValue = [NSString stringWithFormat:@"%d",falseNegatives];
    self.upperBodyTotalPositives.stringValue = [NSString stringWithFormat:@"%d",total];
    
    sens = (float)truePositives / (float)(truePositives + falseNegatives);
    
    self.upperBodySensitivity.stringValue = [NSString stringWithFormat:@"%.5f",sens];
    
    
    // Lower Body -- Compare the results to the ground truth
    [lowerBodyResults compareTo:lowerBodyGroundTruth];
    
    truePositives = [lowerBodyResults truePositives];
    falsePositives = [lowerBodyResults falsePositives];
    falseNegatives = [lowerBodyGroundTruth falsePositives];
    total = [lowerBodyGroundTruth numberOfDetections];
    
    self.lowerBodyTruePositives.stringValue = [NSString stringWithFormat:@"%d",truePositives];
    self.lowerBodyFalsePositives.stringValue = [NSString stringWithFormat:@"%d",falsePositives];
    self.lowerBodyFalseNegatives.stringValue = [NSString stringWithFormat:@"%d",falseNegatives];
    self.lowerBodyTotalPositives.stringValue = [NSString stringWithFormat:@"%d",total];
    
    sens = (float)truePositives / (float)(truePositives + falseNegatives);
    
    self.lowerBodySensitivity.stringValue = [NSString stringWithFormat:@"%.5f",sens];
    
    
    
    // Full Body -- Compare the results to the ground truth
    [fullBodyResults compareTo:fullBodyGroundTruth];
    
    truePositives = [fullBodyResults truePositives];
    falsePositives = [fullBodyResults falsePositives];
    falseNegatives = [fullBodyGroundTruth falsePositives];
    total = [fullBodyGroundTruth numberOfDetections];
    
    self.fullBodyTruePositives.stringValue = [NSString stringWithFormat:@"%d",truePositives];
    self.fullBodyFalsePositives.stringValue = [NSString stringWithFormat:@"%d",falsePositives];
    self.fullBodyFalseNegatives.stringValue = [NSString stringWithFormat:@"%d",falseNegatives];
    self.fullBodyTotalPositives.stringValue = [NSString stringWithFormat:@"%d",total];
    
    sens = (float)truePositives / (float)(truePositives + falseNegatives);
    
    self.fullBodySensitivity.stringValue = [NSString stringWithFormat:@"%.5f",sens];
}

-(BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)sender {
    return YES;
}

- (void)processFiles 
{
    
    
    
}




@end
