//
//  VideoPlayerCV.h
//  VideoTestCV
//
//  Created by Pablo Roldán Ruz on 21/11/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

@class AVAssetReader;
@class AVURLAsset;
@class AVAssetReader;
@class AVAssetReaderTrackOutput;
@class ResultSet;

/*
 * This class plays a video and shows the objects detected in its frames *
 */
@interface VideoPlayerCV : UIViewController {
    // AVFoundation video reader vars
    AVAssetReader *reader;
    AVURLAsset *inputAsset;
    AVAssetReaderTrackOutput *assetReaderOutput;
    NSMutableString *videoFile;
    
    // Frame images
    cv::Mat frame;
    cv::Mat gray;
    
    // Classifiers
    cv::CascadeClassifier faceCascade;
    cv::CascadeClassifier upperBodyCascade;
    cv::CascadeClassifier fullBodyCascade;
    cv::CascadeClassifier lowerBodyCascade;
    
    // Ground truth data
    ResultSet *groundTruth;
    
    // Frame number
    int frameNumber;
    
    
    // FPS Vars
    UILabel *fpsLabel;
    double weightRatio;
    double startTime;
    double endTime;
    double timeFrame;
    double fpsAverage;
    double fpsAverageAgingFactor;
    int	framesInSecond;
}

@property (nonatomic,retain) AVAssetReader *reader;
@property (nonatomic,retain) AVAssetReaderTrackOutput *assetReaderOutput;
@property (nonatomic,retain) AVURLAsset *inputAsset;
@property (nonatomic,retain) NSString *videoFile;
@property (nonatomic,retain) IBOutlet UILabel *fpsLabel;
@property (nonatomic,retain) ResultSet *groundTruth;

// Method to init the video playing
- (void)playVideo;

@end
